# -*- coding: utf8 -*-

from plugmgr import plugin

__all__ = ["sampleconfiguser"]

class sampleconfiguser(plugin):
    """этот плагин просто использует конфиг-менеджер, для проверки...
    используйте команды "set somevalue", "get"
    """
    requires = ["cmd", "config"]
    key = "sampleconfigkey"
    def __init__(self, bot):
        self.bot = bot
        bot["cmd"].addHandler("set", self.handleSet)
        bot["cmd"].addHandler("get", self.handleGet)
        self.bot["config"].setdefault(self.key, u'Sample value', 0, 1)
    def handleGet(self, c):
        value = self.bot["config"][self.key]
        c.reply("%s = %s" % (self.key, value))
    def handleSet(self, c):
        self.bot["config"][self.key] = c.args
        c.reply("Saved.")
    def unload(self):
        self.bot["cmd"].removeHandler("set")
        self.bot["cmd"].removeHandler("get")
